﻿Imports System.Runtime.CompilerServices

Namespace System.Collections.Generic
   Public Module IEnumeratorX
      <DebuggerStepThrough(), Extension()> _
      Public Function Yield(Of T)(enrt As IEnumerator(Of T)) As T
         enrt.MoveNext()
         Return enrt.Current
      End Function
      ''' <summary>Exception on empty collection</summary>
      <DebuggerStepThrough(), Extension()> _
      Public Function YieldCyclic(Of T)(enrt As IEnumerator(Of T)) As T
         With enrt
            If .MoveNext Then Return .Current
            .Reset() : .MoveNext() : Return .Current
         End With
      End Function
      <DebuggerStepThrough(), Extension()> _
      Public Function Yield(enrt As IEnumerator) As Object
         enrt.MoveNext()
         Return enrt.Current
      End Function
      <DebuggerStepThrough(), Extension()> _
      Public Function All(Of T)(enrt As IEnumerator(Of T), condition As Func(Of T, Boolean)) As Boolean
         While enrt.MoveNext
            If Not condition(enrt.Current) Then Return False
         End While
         Return True
      End Function
      <DebuggerStepThrough(), Extension()> _
      Public Function Any(Of T)(enrt As IEnumerator(Of T), condition As Func(Of T, Boolean)) As Boolean
         While enrt.MoveNext
            If condition(enrt.Current) Then Return True
         End While
         Return False
      End Function
      <DebuggerStepThrough(), Extension()> _
      Public Sub ForEach(Of T)(enrt As IEnumerator(Of T), Action As Action(Of T))
         While enrt.MoveNext : Action(enrt.Current) : End While
      End Sub

   End Module
End Namespace